#include <io51.h>

#define   RobotLED    (*(unsigned char *) 0x018000)

#define   RightM_0    INT1
#define   RightM_1    INT0
#define   LeftM_0     T0
#define   LeftM_1     T1

bit OutPulse 	= 0x90;
bit rLSen 	= 0x91;
bit rLCSen 	= 0x92;
bit rCSen 	= 0x93;
bit rRCSen 	= 0x94;
bit rRSen 	= 0x95;

#define		LSensor		0x80	// ʼ 
#define		LCSensor	0x40	//  ߾  
#define		CSensor		0x20	// ߾  
#define		RCSensor	0x10	//  ߾  
#define		RSensor		0x08	//   

#define		Speed		30	// κ ӵ
#define		RightAngle	90	//  ȸ 
#define 	RightTurnSpeed	(Speed + 10)  // ȸӵ

void delay(unsigned int t){
  long i ;

  for(i = 0 ; i < t ; i ++ ) ;
}

//   üũ
unsigned char SensorScan(void){
    unsigned char ScanData = 0;

    OutPulse = 1;			// Sensor ON
    delay(14);
    if(rLSen == 0)		ScanData = ScanData | 0x80;
    if(rLCSen == 0)		ScanData = ScanData | 0x40;
    if(rCSen == 0)		ScanData = ScanData | 0x20;
    if(rRCSen == 0)		ScanData = ScanData | 0x10;
    if(rRSen == 0)		ScanData = ScanData | 0x08;
    OutPulse = 0;			// Sensor OFF
    return (ScanData);
}

void SlowGo(long dest){
   long i;

   for(i=0;i<dest;i++)
   {
	LeftM_0 = 1;		LeftM_1 = 0;	//,  
	RightM_0 = 1;		RightM_1 = 0;  
	delay(Speed);
	
	LeftM_0 = 0;		LeftM_1 = 0;	//
	RightM_0 = 0;		RightM_1 = 0;  
	delay(15);
	
	LeftM_0 = 1;		LeftM_1 = 1;	// ,  
	RightM_0 = 1;		RightM_1 = 1;
	delay(100-Speed);
   }
}


// ʹ ,   , RightAngleŭ ȸ
void RotateRight(long rotangle){
	long i;

	for(i=0;i<rotangle;i++)
	{
	    LeftM_0 = 1;		LeftM_1 = 0;	
	    RightM_0 = 1;		RightM_1 = 1;
	    delay(RightTurnSpeed);
	    LeftM_0 = 0;		LeftM_1 = 0;	//
	    RightM_0 = 0;		RightM_1 = 0;  
	    delay(15);
	    LeftM_0 = 1;		LeftM_1 = 1;
	    RightM_0 = 1;		RightM_1 = 1;
	    delay(100-RightTurnSpeed);
	}
}

void RightTurn(void)
{
	SlowGo(40);			// ణ  ̵
	RotateRight(RightAngle);	//  ȸ 
	while(!(SensorScan() & 0x40))	RotateRight(1);
}

void main(void)
{
   unsigned char ReadData;

   for(;;){
	//  üũ
	ReadData = SensorScan();
	RobotLED = ReadData;		// LED ǥ

	//   ,   
	LeftM_0 = 1;		LeftM_1 = 0;
	RightM_0 = 1;		RightM_1 = 0;

	switch(ReadData)
	{
	   //   
	   // ʹ : ,   : 
	   case CSensor :  
		LeftM_0 = 1;     	LeftM_1 = 0;
		RightM_0 = 1;		RightM_1 = 0;	
		delay(Speed);
		break;
	   //  κ  Ʋ 
	   // ʹ : ,    : 
	   case CSensor | RCSensor : 
 	   case RCSensor | RSensor : 
   	   case RSensor :
	   case RCSensor :
		LeftM_0	= 1; 		LeftM_1 = 0;
		RightM_0 = 1;		RightM_1 = 1;
		delay(Speed+10);
		break;
 	   //  κ  Ʋ 
	   //   : ,   : 
	   case CSensor | LCSensor : 	
	   case LCSensor | LSensor :		
	   case LSensor :
	   case LCSensor :
		LeftM_0 = 1;		LeftM_1 = 1;
		RightM_0 = 1;		RightM_1 = 0;
		delay(Speed+10);
		break;
	   // ֹ ִ  ϴ κ  Ų.
           case CSensor | LCSensor | RCSensor :	
	     LeftM_0 = 0;		LeftM_1 = 0;	//
	     RightM_0 = 0;		RightM_1 = 0;  
	     delay(15);

	     LeftM_0 = 1;		LeftM_1 = 1;
	     RightM_0 = 1;		RightM_1 = 1;
	     delay(Speed);
	     break;
	   //  ,  ߾ ,   
	   // ?    ȸ
	   case CSensor | RCSensor | RSensor :
	   // ?    ȸ	
	   case CSensor | RCSensor | RSensor | LCSensor :
	   // ?, T    ȸ
	   case CSensor | LCSensor | LSensor | RCSensor | RSensor :
	     RightTurn();
	     break;
	   case 0x00 :	//     
	     LeftM_0 = 0;		LeftM_1 = 0;	//
	     RightM_0 = 0;		RightM_1 = 0;  
	     delay(15);
	   
	     LeftM_0 = 1;	LeftM_1 = 1;
	     RightM_0 = 1;	RightM_1 = 1;
	     break;
        }
	LeftM_0 = 0;		LeftM_1 = 0;	//
	RightM_0 = 0;		RightM_1 = 0;  
	delay(15);
     	
     	LeftM_0 = 1;		LeftM_1 = 1;
	RightM_0 = 1;		RightM_1 = 1;
	delay(38);
   }
}
