#include <io51.h>

#define   RobotLED    (*(unsigned char *) 0x018000)

#define   RightM_0    INT1
#define   RightM_1    INT0
#define   LeftM_0     T0
#define   LeftM_1     T1

bit OutPulse 	= 0x90;
bit rLSen 	= 0x91;
bit rLCSen 	= 0x92;
bit rCSen 	= 0x93;
bit rRCSen 	= 0x94;
bit rRSen 	= 0x95;

#define		LSensor		0x80	// ʼ 
#define		LCSensor	0x40	//  ߾  
#define		CSensor		0x20	// ߾  
#define		RCSensor	0x10	//  ߾  
#define		RSensor		0x08	//   

#define		FrontGO			1
#define		TurnLeft		2
#define		TurnRight		3
#define		TurnReverse		4
#define		Finish			0

//ӵ 
#define		Battary		  	3
#define		Speed			(90 / Battary)
#define		LeftTurnSpeed		(Speed + 10)
#define		RightTurnSpeed		(Speed + 10)
#define		SlowSpeed		(Speed - 5)

//
#define		RightAngle		90
#define		LeftAngle		90
#define		UTAngle			90

#define		LEDOFF			0xFF

// 
unsigned char Job[20] = {3, 1, 3, 2, 3, 3, 1, 3, 3, 3, 2, 2, 1, 2, 1, 2, 0 };
unsigned char position;

void delay(unsigned int t){
  long i ;
  for(i = 0 ; i < t ; i ++ ) ;
}

//   üũ
unsigned char SensorScan(void){
    unsigned char ScanData = 0;

    OutPulse = 1;			// Sensor ON
    delay(14);
    if(rLSen == 0)		ScanData = ScanData | 0x80;
    if(rLCSen == 0)		ScanData = ScanData | 0x40;
    if(rCSen == 0)		ScanData = ScanData | 0x20;
    if(rRCSen == 0)		ScanData = ScanData | 0x10;
    if(rRSen == 0)		ScanData = ScanData | 0x08;
    OutPulse = 0;			// Sensor OFF
    return (ScanData);
}

void SlowGo(long mValue){
   long i;

   for(i=0;i<mValue;i++)
   {
	LeftM_0 = 1;		LeftM_1 = 0;	//,  
	RightM_0 = 1;		RightM_1 = 0;  
	delay(SlowSpeed);
	LeftM_0 = 0;		LeftM_1 = 0;	//
	RightM_0 = 0;		RightM_1 = 0;  
	delay(15);
	LeftM_0 = 1;		LeftM_1 = 1;	// ,  
	RightM_0 = 1;		RightM_1 = 1;
	delay(100-SlowSpeed);
   }
}

void SlowBack(long mValue)
{
   long i;

   for(i=0;i<mValue;i++)
   {
	LeftM_0 = 0;		LeftM_1 = 1;	//  
	RightM_0 = 0;		RightM_1 = 1;	//  
	delay(SlowSpeed);
	LeftM_0 = 0;		LeftM_1 = 0;	//
	RightM_0 = 0;		RightM_1 = 0;  
	delay(15);
	LeftM_0 = 1;		LeftM_1 = 1;
	RightM_0 = 1;		RightM_1 = 1;
	delay(100-SlowSpeed);
   }
}

// ʹ ,   , rotangleŭ ȸ
void RotateRight(long rotangle)
{
    long i;

    for(i=0;i<rotangle;i++){
 	LeftM_0 = 1;		LeftM_1 = 0;	// 	
	RightM_0 = 1;		RightM_1 = 1;	// 
	delay(RightTurnSpeed);
	LeftM_0 = 0;		LeftM_1 = 0;	//
	RightM_0 = 0;		RightM_1 = 0;  
	delay(15);
	LeftM_0 = 1;		LeftM_1 = 1;
	RightM_0 = 1;		RightM_1 = 1;
	delay(100-RightTurnSpeed);
    }
}

// ʹ ,   , rotangleŭ ȸ
void RotateLeft(long rotangle)
{
   long i;

   for(i=0; i<rotangle;i++)
   {
 	LeftM_0 = 1;	LeftM_1 = 1;		// 
	RightM_0 = 1;	RightM_1 = 0;		// 
	delay(LeftTurnSpeed);
	LeftM_0 = 0;		LeftM_1 = 0;	//
	RightM_0 = 0;		RightM_1 = 0;  
	delay(15);
	LeftM_0 = 1;		LeftM_1 = 1;
	RightM_0 = 1;		RightM_1 = 1;
	delay(100-LeftTurnSpeed);
   }
}

// ʹ U 
void RotateReverse(long rotangle)
{
   long i;

   for(i=0; i<rotangle;i++)
   {
 	LeftM_0 = 0;	LeftM_1 = 1;		// 
	RightM_0 = 1;	RightM_1 = 0;		// 
	delay(100);
	LeftM_0 = 0;		LeftM_1 = 0;	//
	RightM_0 = 0;		RightM_1 = 0;  
	delay(15);
	LeftM_0 = 1;		LeftM_1 = 1;
	RightM_0 = 1;		RightM_1 = 1;
	delay(220);
   }
}

// ȸ
void RightTurn(void)
{
   SlowGo(40);		// ణ  ̵
   RotateRight(RightAngle);//  ȸ 
   while(!(SensorScan() & 0x40))	RotateRight(1);
}

// ȸ
void LeftTurn(void)
{
   SlowGo(40);		// ణ  ̵
   RotateLeft(LeftAngle);	//  ȸ
   while(!(SensorScan() & 0x10))	RotateLeft(1);
}

//U-Turn
void UTurn(void)
{
   SlowBack(40);		// ణ ڷ ̵
   RotateReverse(UTAngle);	//  ȸϸ鼭 U
   while(!(SensorScan() & 0x40))	RotateReverse(1);
}

//
void ForwardMovement(void)
{
	SlowGo(70);
}

// 
void MiroRun(void)
{
	switch(Job[position])
	{
		case FrontGO : 
			ForwardMovement();
			break;
		case TurnReverse :
			UTurn();
			break;
	     	case TurnRight :
			RightTurn();
			break;
		case TurnLeft :
			LeftTurn();
			break;
		case Finish :
			SlowGo(60);
			//
			LeftM_0 = 0;		LeftM_1 = 0;
			RightM_0 = 0;		RightM_1 = 0;  
			delay(15);
			//κ
			LeftM_0 = 1;		LeftM_1 = 1;
			RightM_0 = 1;		RightM_1 = 1;
			RobotLED = LEDOFF;
			while(1);
			break;
	}
	position = position + 1;
}

void main(void)
{
   unsigned char ReadData;

   for(;;){
	//  üũ
	ReadData = SensorScan();
	RobotLED = ReadData;		// LED ǥ

	//   ,   
	LeftM_0 = 1;		LeftM_1 = 0;
	RightM_0 = 1;		RightM_1 = 0;

	switch(ReadData)
	{
 	   //   
	   // ʹ : ,   : 
	   case CSensor :  
		LeftM_0 = 1;     	LeftM_1 = 0;
		RightM_0 = 1;		RightM_1 = 0;	
		delay(Speed);
		break;

	   //  κ  Ʋ 
	   // ʹ : ,    : 
	   case CSensor | RCSensor : 
 	   case RCSensor | RSensor : 
   	   case RSensor :
	   case RCSensor :
		LeftM_0	= 1; 		LeftM_1 = 0;
		RightM_0 = 1;		RightM_1 = 1;
		delay(Speed+10);
		break;

	    //  κ  Ʋ 
	    //   : ,   : 
	    case CSensor | LCSensor : 	
	    case LCSensor | LSensor :		
	    case LSensor :
	    case LCSensor :
		LeftM_0 = 1;			LeftM_1 = 1;
		RightM_0 = 1;			RightM_1 = 0;
	   	delay(Speed-3);
		break;

	   //  ߰,  ߰,    - T 
	   case CSensor | LCSensor | RCSensor :
	   //  ,  ߰,   - ? 
	   case CSensor | RCSensor | RSensor :
           // ʼ,  ߰, ,  ߰ - ? 
	   case CSensor | RCSensor | RSensor | LCSensor :
	   // ʼ, ߰, ,  ߰  - 
	   case CSensor | LCSensor | LSensor | RCSensor :
	   //     - T  Ǵ + 
	   case CSensor | LCSensor | LSensor | RCSensor | RSensor :
	   //  ,  ߰,   - ? 
	   case CSensor | LCSensor | LSensor :
	   // Ͼ   
	   case 0x00 :
		MiroRun();	// ̸   δ.
	     	break;
        }
	LeftM_0 = 0;		LeftM_1 = 0;	//
	RightM_0 = 0;		RightM_1 = 0;  
	delay(15);
	LeftM_0 = 1;		LeftM_1 = 1;	//
	RightM_0 = 1;		RightM_1 = 1;
	delay(38);
   }
}
